/*
TASK:perm
LANG:C++
*/

#include <cstdio>

const int MAXN = 64;
const int BASE = 1000000000;


int N;
int opt[MAXN][MAXN][10];
int sum[MAXN][10];

void substract (int n, int mr) {
	int mr1 = mr-1;
    int mr2 = mr-2;
    int n1 = n;
    int n2 = n-1;

    bool naum = 0;
    int i;
    for (i = 0; i < 10; ++i) {
    	if (naum) {
	        opt[n][mr][i] = opt[n1][mr1][i] - opt[n2][mr2][i] - 1;
            	if (opt[n][mr][i] < 0)
                	opt[n][mr][i] += BASE;
                else
                	naum = 0;
        } else {
    		opt[n][mr][i] = opt[n1][mr1][i] - opt[n2][mr2][i];
            naum = 0;
        	if (opt[n][mr][i] < 0) {
            	opt[n][mr][i] += BASE;
            	naum = 1;
            }
        }
    }
}

void add (int a, int b, int a1, int b1) {
    int prenos = 0, i;
	for (i = 0; i < 10; ++i) {
    	opt[a][b][i] += opt[a1][b1][i] + prenos;
        prenos = opt[a][b][i] / BASE;
        opt[a][b][i] %= BASE;
    }
}


int main () {
	scanf ("%d", &N);

    int i,j,k;
    
    N++;
    opt[1][1][0] = 1;
    for (i = 2; i <= N; ++i) {
        for (j = 0; j < i; ++j)
        	add (i,1,i-1,j);

	    for (j = 2; j <= i; ++j)
          	substract (i,j);
    }
    N--;

    bool flag = 0;
    for (i = 9; i >= 0; --i) {
    	if (flag || opt[N+1][1][i] > 0)
        	printf ("%d", opt[N+1][1][i]);
    }
    printf ("\n");

/*    for (i = 1; i <= N; ++i) {
    	for (j = 1; j <= i; ++j) {
            flag = 0;
            for (k = 9; k >= 0; --k)
            	if (flag || opt[i][j][k] > 0) {
                	flag = 1;
        			printf ("%d", opt[i][j][k]);
                }
            printf (" ");
        }
        printf ("\n");
    }
*/
/*    for (i = 1; i <= N; ++i)
    	for (j = 1; j <= i; ++j)
        	sum[i] += opt[i][j];
	for (i = 1; i <= N; ++i)
    	printf ("%lld\n", sum[i]);
*/
	return 0;
}
