/*
TASK:perm
LANG:C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

short n, x, y, a[51];
unsigned long f[51][51];

char check(void)
{
  short i, j, k;
  for(i = 0; i < n; i++)
    for(j = i+1; j < n; j++)
      for(k = j+1; k < n; k++)
        if(a[i]>a[j] && a[j] > a[k])
          return 0;
  return 1;
}

int cmp(const void *a, const void *b)
{
  if(*(short*)a < *(short*)b)
    return -1;
  if(*(short*)a > *(short*)b)
    return 1;
  return 0;
}

char next(void)
{
  short i, j, t;
  for(i = n-2; i>=0; i--)
    for(j = n-1; j>i; j--)
      if(a[i]<a[j])
      {
        t=a[i];
        a[i]=a[j];
        a[j]=t;
        qsort(&a[i+1], n-i-1, sizeof(short), cmp);
        return 1;
      }
  return 0;
}

int main(void)
{
  memset(f, 0, 51*51*sizeof(unsigned long));
  scanf("%hd", &n);
  for(x =0; x < n; x++)
    scanf("%hd", &a[x]);
  for(x = 0; x <= n; x++)
    f[x][0] = 1;
  for(x = 0; x <= n; x++)
    for(y = 1; y < x; y++)
      f[x][y] = f[x][y-1]+f[x-1][y];
  for(y = x = 0; x < n; x++)
    y += f[n][x];
  printf("%lu\n", y);
  while(next())
    if(check())
    {
      for(x = 0; x < n; x++)
        if(x==n-1)
          printf("%hd\n", a[x]);
        else
          printf("%hd ", a[x]);
      return 0;
    }
  for(x = 0; x < n; x++)
    printf("%hd ", x+1);
  printf("\n");
  return 0;
}
