/*
TASK:present
LANG:C
*/
#include <stdio.h>
#include <string.h>

#define MAXN 10000000

long long a, b, c, n;
char f[MAXN+1];

void initf(void)
{
  long l;
  l = c<MAXN?c:MAXN;
  memset(f, 0, l*sizeof(char));
  f[0] = 1;
  f[a] = 1;
  f[b] = 1;
  for(n = (a>b?a:b)+1; n <= l; n++)
    f[n] = f[n-a] || f[n-b];
}

char pres(long n)
{
  if(n <= MAXN)
    return f[n];
  if(n%a == 0 || n%b == 0)
    return 1;
  return pres(n-a)||pres(n-b);
}

int main(void)
{

  scanf("%Ld %Ld %Ld", &a, &b, &c);
  if(a == 1 || b == 1)
  {
    printf("-1\n");
    return 0;
  }
  initf();
  for(n=c; n && pres(n); n--);
  printf("%Ld\n", n);
  return 0;
}
