/*
TASK:PERM
LANG:C++
*/

#include <stdio.h>
#include <string.h>

int n;
int l, r;
long long _G[55][55]={0};
int _P[55];

inline int dyn(int n, int x) {
    int i, j, k, l, bla;
    for (i=1; i<=n; i++)
        _G[i][i]=1;
	for (i=1; i<=n; i++)
        for (j=1; j<i; j++) {
    		for (k=i-1,bla=0; k>=i-j; k--, bla++)
    			for (l=j-bla; l<=k; l++)
            		_G[i][j]+=_G[k][l];
            if (i==n&&j==x)
            	return _G[i][j];
        }
}

/*
int rec(int n, int x) {
    int sum=0, i, j, bla;
    if (n==x) return 1;
    if (n<1||x<1) return 0;
    for (i=n-1,bla=0; i>=n-x; i--, bla++)
    	for (j=x-bla; j<=i; j++)
        	sum+=rec(i,j);
    return sum;
}
*/

int max=0;
int used[55]={0};

bool rec(int i, int max) {
    int j, k, l;
    used[_P[i]]=1;
/*
    if (i==n&&!(_P[i]<max&&!used[_P[i]-1]))
    	return true;
*/
    if (i>n) {
    	used[_P[i]]=0;
    	return false;
    }
	if (_P[i]<max&&!used[_P[i]-1]||!rec(i+1, (max>_P[i]) ? max:_P[i])) {
        for (j=(max>_P[i] ? max:_P[i] )+1;used[j]&&j<=n;j++);
        if (j<=n) {
            _P[i]=j;
            memset(used, 0, sizeof(used));
            for (k=1; k<=i; k++)
            	used[_P[k]]=1;
            for (k=i+1; k<=n; k++)
            	for (l=1; l<=n; l++)
                	if (!used[l]) {
                    	_P[k]=l;
                        used[l]=1;
                        break;
                    }
            return true;
        }
        else {
    		used[_P[i]]=0;
        	return false;
    	}
    }
    return true;
}

inline bool valid() {
	int i, j, k;
    for (i=1; i<=n; i++)
    	for (j=i+1; j<=n; j++)
        	for (k=j+1; k<=n; k++)
                if (_P[i]>_P[j] && _P[j]>_P[k])
                	return false;
    return true;
}

int npused[55]={0};
bool nprec(int i) {
	int j, k, l;
    npused[_P[i]]=1;
    if (i==n) {
    	npused[_P[i]]=0;
    	return false; }
    if (nprec(i+1))
    	return true;
    for (j=_P[i]+1; npused[j]&&j<=n; j++);
    if (j<=n) {
        _P[i]=j;
            memset(npused, 0, sizeof(npused));
            for (k=1; k<=i; k++)
            	npused[_P[k]]=1;
        for (k=i+1; k<=n; k++)
        	for (l=1; l<=n; l++)
            if (!npused[l]) {
            	_P[k]=l;
                npused[l]=1;
                break;
            }
        return true;
    }
    npused[_P[i]]=0;
    return false;
}

int main() {
    //freopen("perm.in", "r", stdin);
	scanf("%d", &n);
    for (int i=1; i<=n; i++)
    	scanf("%d", _P+i);
    printf("%d\n", dyn(n+1,1));
    if (valid()&&!nprec(1))
    	goto qqqqq;
    if (valid())
    	goto pppp;
    
    if (rec(1,0)) {
    	pppp:;
    	for (int i=1; i<n; i++)
        	printf("%d ", _P[i]);
        printf("%d\n", _P[n]);
    }
    else {
    	qqqqq:;
    	for (int i=1; i<n; i++)
        	printf("%d ", i);
        printf("%d\n", n);
    }
	return 0;
}

