/*
TASK:perm
LANG:C
*/
#include <stdio.h>
#include <stdlib.h>

 long n;
 long p[64];
 long a[64];
 long f;
 long long r[2];

 void show ()
  {
   long i;
   for (i=1;i<=n;i++)
    {
     printf("%ld",a[i]);
     if (i!=n) printf(" ");
    }
   printf("\n");
   exit (0);
  }

 void quit ()
  {
   long i;
   for (i=1;i<=n;i++) a[i]=i;
   show();
  }

 void swap (long i,long j)
  {
   long t;
   t=a[i];
   a[i]=a[j];
   a[j]=t;
  }

 void sort (long t)
  {
   long i,j,k;
   for (i=t;i<=n;i++)
    for (j=i+1;j<=n;j++)
     if (a[i]>a[j])
      {
       k=a[i];
       a[i]=a[j];
       a[j]=k;
      }
  }

 long check ()
  {
   long x,y,z;
   for (y=1;y<=n;y++)
    for (x=1;x<y;x++)
     for (z=y+1;z<=n;z++)
      if (a[x]>a[y] && a[y]>a[z]) return y;
   return 0;
  }

 long get (long i)
  {
   long j,o;
   o=0;
   for (j=i+1;j<=n;j++)
    if (a[j]>a[i] && (o==0 || a[o]>a[j]))
     o=j;
   return o;
  }
  
 void good ()
  {
   long h,i,j;
   while ((h=check())!=0)
    {
     for (i=h;i>=1;i--)
      if ((j=get(i))!=0)
       break;
     if (i==0) quit();
     swap(i,j);
     sort(i+1);
     f=1;
    }
  }

 long gcd (long a,long b)
  {
   long tmp;
   if (a<b)
    {
     tmp=a;
     a=b;
     b=tmp;
    }
   while (b!=0)
    {
     tmp=a%b;
     a=b;
     b=tmp;
    }
   return a;
  }

 void next ()
  {
   long i,j;
   i=n-1;
   while (a[i]>a[i+1]) i--;
   if (i==0) quit();
   for (j=n;j>i;j--)
    if (a[j]>a[i]) break;
   swap(i,j);
   i++;
   j=n;
   while (i<j)
    {
     swap(i,j);
     i++;
     j--;
    }
   f=1;
  }

 int main ()
  {
   long i,j,t,NOD,pom;
   long long o;
   o=1;
   for (i=1;i<=13;i++) o*=10;
   scanf("%ld",&n);
   for (i=1;i<=n;i++)
    p[i]=i+n;
   for (i=1;i<=n+1;i++)
    {
     pom=i;
     t=1;
     while (pom!=1)
      {
       NOD=gcd(pom,p[t]);
       pom/=NOD;
       p[t]/=NOD;
       t++;
      }      
    }

   r[0]=1;
   for (i=1;i<=n;i++)
    {
     r[1]*=(long long)p[i];
     r[1]+=(r[0]*(long long)p[i])/o;
     r[0]=(r[0]*(long long)p[i])%o;
    }
   if (r[1]!=0) printf("%lld",r[1]);
   printf("%lld\n",r[0]);

   for (i=1;i<=n;i++)
    scanf("%ld",&a[i]);
   good();
   while (1)
    {
     if (f==1 && check()==0) break;
     next();
     good();
    }
   show();
   return 0;
  }
