/*
TASK:present
LANG:C++
*/
#include <stdio.h>
#include <string.h>

int iA,iB,iMax;

void load()
{
	scanf("%d%d%d",&iA,&iB,&iMax);

	if (iB<iA) {
		int tmp = iA;
		iA = iB;
		iB = tmp;
	}
}

int gcd(int i1,int i2)
{
	int tmp;
	
	if (i1<i2) {
		tmp = i1;
		i1 = i2;
		i2 = tmp;
	}
		
	int iRem;
	
	while (iRem > 0) {
		iRem = i1 % i2;
		tmp = i1/i2;
		i1=i2;
		i2=tmp;
	}

	return i1;
}

int max(int i1,int i2)
{
	return i1 > i2 ? i1 : i2;
}

void save(int iR)
{
	printf("%d\n",iR);
}

int solve()
{
	if (iA==1)
		return -1;

	int i_gcd = gcd(iA,iB);
	if (iMax % i_gcd != 0)
		return iMax;

	if (i_gcd != 1) 
		return iMax - 1;

	bool *can_do = new bool[iMax+1+iA+iB];
	memset(can_do,0,sizeof(can_do));

	int iR=-1;
	int iL=0;
	can_do[0] = true;
	can_do[iA] = true;
	can_do[iB] = true;	
	for (int i=1;i<=iMax;i++) 
		if (can_do[i]) {
			can_do[i+iA] = true;
			can_do[i+iB] = true;
			iL++;
			if (iL == iA)
				return iR;
		} else {
			iL = 0;
			iR = i;			
		}	

	return iR;
}

int main()
{
	load();
	save(solve());
	
	return 0;
}

