/*
TASK:perm
LANG:C
*/

#include<stdio.h>

#define MAX 55

int easy ();

int A[MAX], B[MAX], n;
int X[MAX];
int N[MAX]={0,1,2,5,14,42};

void swap (int *a, int *b)
{ int x=*a; *a=*b; *b=x; }

void init ()
{
   int i;

   for (i=1; i<=n; i++)
      B[i]=i;
}

void qsort (int l, int r)
{
   int i=l, j=r, x, mid=B[ A[(i+j)/2] ];

   while (i<=j)
   {
      while ( B[ A[i] ] < mid ) i++;
      while ( B[ A[j] ] > mid ) j--;
      if (i<=j)
      {
         swap (&B[ A[i] ], &B[ A[j] ]);
         i++; j--;
      }
   }

   if (l<j) qsort (l, j);
   if (i<r) qsort (i, r);
}

void vhod ()
{
   int i;

   scanf ("%d", &n);

   for (i=1; i<=n; i++)
      scanf ("%d", &A[i]);
}

void solve1 ()
{
   printf ("%d\n", N[n]);
}

void output ()
{
   int i;

   for (i=1; i<=n; i++)
      printf ("%d ", A[i]);
}

int check ()
{
   int i, j;

   X[n]=0;

   for (i=n-1; i>0; i--)
   {
      for (j=i+1; j<=n; j++)
         if (A[i]>A[j])
         {
            X[i]=X[j]+1;
            if (X[i]>1) return 0;
            goto L1;
         }
      X[i]=0;
     L1:
   }

   return 1;
}

int easy ()
{
   int i;

   if (A[1] != n) return 0;

   for (i=2; i<=n; i++)
      if (A[i] != i-1) return 0;

   for (i=1; i<=n; i++)
      printf ("%d ", i);
      
   return 1;
}

void solve2 ()
{
   int i, j;

   if (easy()) return;

   if (check())
   {
      for (i=n; i>0; i--)
         for (j=i-1; j>0; j--)
            if (A[j]<A[i])
            {
               swap (&A[i], &A[j]);
               goto L2;
            }
     L2:
      if (check()) { output (); return; }
   }

   qsort (1, n);

   for (i=n-1; i>0; i--)
      for (j=A[i]+1; j<=n; j++)
         if (B[j]>i)
         {
            swap (&A[i], &A[ B[j] ]);

            if (check()) { output (); return; }

            swap (&A[i], &A[ B[j] ]);
         }
}

int main ()
{
   vhod ();
   init ();
   solve1 ();
   solve2 ();

   return 0;
}