/*
TASK:perm
LANG:C
*/

#include <stdio.h>

#define MAXN 64
#define MAX(a , b) ((a) > (b) ? (a) : (b))

int n;
int beg[MAXN];

typedef struct {
    int d[100];
    int br;
} dlg;

dlg t[MAXN], mas[MAXN][MAXN], f[MAXN];

void add(dlg *a, dlg *b) {
    int i, j;
    j = MAX(a->br, b->br);
    for(i = 0; i <= j; i++) {
	a->d[i] += b->d[i];
	a->d[i + 1] += a->d[i]/10;
	a->d[i] %= 10;
    }
    a->br = j;
    if(a->d[j]) a->br++;
}

void printdlg(dlg *a) {
    int i;
    for(i = a->br - 1; i >= 0; i--) printf("%d",a->d[i]);
    if(a->br == 0) printf("0");
    printf("\n");
}

void clear(dlg *a) {
    int i;
    for(i = 0; i < a->br; i++) a->d[i] = 0;
    a->br = 0;
}

int cmp(dlg *a, dlg *b) {
    int i;
    if(a->br != b->br) return a->br - b->br;
    for(i = a->br - 1; i >= 0; i--)
	if(a->d[i] != b->d[i]) return a->d[i] - b->d[i];
    return 0;
}

/*void cdpr(int *a, dlg *b) {
    int i;
    clear(&b);

    for(i 
}*/

int main() {
    register int i, j, k;

    scanf("%d",&n);
    for(i = 0; i < n; i++) scanf("%d", &beg[i]);

    t[1].br = t[1].d[0] = 1; 
    mas[1][0].br = mas[1][0].d[0] = 1;

    for(i = 2; i <= n; i++) {
	for(j = 0; j < i; j++) {
	    for(k = j; k < i; k++) {
		add(&mas[i][k], &mas[i-1][j]);
		add(&t[i], &mas[i-1][j]);
	    }
	}
    }

    printdlg(&t[n]);

    f[0].br = f[0].d[0] = 1;
    for(i = 1; i <= n; i++)
	for(j = 0; j < i; j++) add(&f[i], &f[i-1]);

    printf("1");
    for(i = 2; i<=n;i++) printf(" %d",i);
    printf("\n");

    return 0;
}

