/*
TASK: mirrors
LANG: C
*/

#include <stdio.h>

#include "module.h"

int n,m,p;
int mirrors[128],states[128];
int henzel,gretel;

int used[128];

void rec2(int cp,int end)
{
	int i;

    if ( cp == end )
    {
        getView(end,mirrors,states,&henzel,&gretel);
        return;
    }

    for ( i = 0 ; i < 3 ; i++ )
	{
    	states[cp] = i;
        rec2(cp+1,end);
    }
}



void rec(int cp,int end)
{
	int i;

    if ( cp == end )
    {
        rec2(0,end);
        return;
    }

    for ( i = 0 ; i < p ; i++ )
		if ( !used[i] )
        {
        	used[i] = 1;
            mirrors[cp] = i;
            rec(cp+1,end);
        	used[i] = 0;
        }
}

int main(void)
{
	int i,j,k,l;

    init();
	n = getN();
    m = getM();
    p = getP();

    for ( i = 1 ; i <= 6 ; i++ )
    	rec(0,i);

    return 0;
}
