{
TASK:perm
LANG:Pascal
}
program PERM;
type TPerm=array[1..50] of byte;
var x,maxperm,cperm:TPerm;

    used:array[1..50] of BOOLEAN;
    perms:word;
    N:byte;


procedure Input;
var i:byte;
begin
 readln(N);
 for i:=1 to N do read(x[i]);
 readln;
end;

function IsPerm(a1,a2,a3:byte):BOOLEAN;
begin
 If (a1>a2) and (a2>a3) then IsPerm:=FALSE
 else IsPerm:=TRUE;
end;

function CheckPerm(lng:byte):BOOLEAN;
var i,j,k:byte;
begin
 CheckPerm:=TRUE;
 If (lng<3) then begin
  CheckPerm:=TRUE;
  exit;
 end;
 for i:=1 to lng-2 do begin
  for j:=i+1 to lng-1 do begin
   for k:=j+1 to lng do begin
    If not(IsPerm(cperm[i],cperm[j],cperm[k])) then begin
     CheckPerm:=FALSE;
     exit;
    end;
   end;
  end;
 end;
end;

function IsSmaller:BOOLEAN;
var i:byte;
begin
 IsSmaller:=FALSE;
 for i:=1 to N do begin
  If (cperm[i]<maxperm[i]) then begin
   IsSmaller:=TRUE;
   exit;
  end;
  If (cperm[i]>maxperm[i]) then begin
   IsSmaller:=FALSE;
   exit;
  end;
 end;
end;

function IsBigger:BOOLEAN;
var i:byte;
begin
 IsBigger:=FALSE;
 for i:=1 to N do begin
  If (cperm[i]>x[i]) then begin
   IsBigger:=TRUE;
   exit;
  end;
  If (cperm[i]<x[i]) then begin
   IsBigger:=FALSE;
   exit;
  end;
 end;
end;

procedure SetPerm;
begin
 maxperm:=cperm;
end;

procedure GenPerms(count:integer);
var i:byte;
begin
 If (count>N) then begin

  inc(perms);
  If (IsSmaller) and (IsBigger) then SetPerm;

 end else begin

  for i:=1 to N do begin
   If not(Used[i]) then begin
    Used[i]:=TRUE;
    cperm[count]:=i;
    If (CheckPerm(count)) then GenPerms(count+1);
    Used[i]:=FALSE;
   end;
  end;

 end;
end;

procedure Output;
var i:byte;
begin
 writeln(perms);
 If not(maxperm[1]=maxperm[2]) then begin
  for i:=1 to N-1 do write(maxperm[i],' ');
  writeln(maxperm[N]);
 end else begin
  for i:=1 to N-1 do write(i,' ');
  writeln(N);
 end;
end;

begin
 Input;
 FillChar(maxperm,SizeOf(maxperm),N);
 perms:=0;
 GenPerms(1);
 Output;
end.