/*
TASK:present
LANG:C++
*/
#include <iostream>
#include <cstdlib>
#include <vector>
using namespace std;

long long a,b,c;
vector<bool> D(4000100);

int gcd(int a, int b) {
	if(b==0) return a;
    return gcd(b,a%b);
}

void Solve1(void) {
	int i;
    int Best=-1;
    D[0]=1;
    for(i=a; i<=c; i+=a) if(D[i-a]==1) D[i]=1;
    for(i=b; i<=c; i++)
    {
		if(D[i-b]==1) D[i]=1;
        if(D[i]==0) Best=i;
    }

//    for(i=1; i<=(1500);i++) printf("D[%d]=%d\n",i,D[i]);
//	cout << Best << " " << D[c] << endl;
	if(D[c]==0) cout << c << endl;
    else cout << Best << endl;
	exit(0);
}

int Check(long long t) {
	long long a1,b1,t1;
    if(t%a==0 || t%b==0) return 1;
    a1 = a;
    b1 = b;
    t1 = a;
    for(;t1+b<=t; t1+=a)
    {
    	long long q = c-t1;
        if(q%b==0) return 1;
    }
    return 0;
}

void Solve2() {
    for(; c>=-1; c--)
    {
    	if(Check(c)==0)
        {
        	cout << c << endl;
            exit(0);
        }
    }
}

void Init(void) {
	int i;
    cin >> a >> b >> c;
    //cout << a << " " << b << " " << c << endl;
     int g=gcd(a,b);
     long long o = a*b-a-b;
     if(g==1 && o<=c)
     {
        cout << o << endl;
        exit(0);
     }
     if(a==1 || b==1) { cout << -1 << endl; exit(0); }
     if(c<=4000000) Solve1();
     Solve2();

}

int main(void) {
	Init();
    //printf("%d\n",gcd(a,b));
	return 0;
}

